class Point
{
  Direction going;
  PVector pos;
  float speed;
  float size;
  boolean pop = false;
  int[] col = new int[3];
  public Point(PVector p, Direction d, float s, float z)
  {
    pos = p.copy();
    going = d;
    speed = s;
    size = z;
    col = genColor(100,255); //gen new color, replace if child
  }
  public void draw(float dt)
  {
    PVector old = pos.copy();
    switch (going)
    {
      case NE:
      pos.add(speed*dt, speed*dt);
        break;
      case SE:
      pos.add(speed*dt, -speed*dt);
        break;
      case SW:
      pos.add(-speed*dt, -speed*dt);
        break;
      case NW:
      pos.add(-speed*dt, speed*dt);
        break;
    }
    stroke(#ffffff);
    strokeWeight(size);
    strokeCap(PROJECT);
    line(old.x, old.y, pos.x, pos.y);
    if ((int)random(0, sqrt(size*100)) == 0)
    {
      pop = true;
    }
  }
}

int[] genColor(int min, int max)
{
  return new int[]{(int)random(min,max),(int)random(min,max),(int)random(min,max)};
}

enum Direction
{
  NE, SE, SW, NW
}

static final Direction[] ds = new Direction[]{Direction.NE, 
                                              Direction.SE, 
                                              Direction.SW, 
                                              Direction.NW};

Direction getRandomDir()
{
  return ds[(int)random(0,4)];
}

Direction[] getDirsFrom(Direction prev)
{
  Direction d[] = new Direction[3];
  switch (prev)
    {
      case NE: 
        d[0]=Direction.NW;
        d[1]=Direction.NE;
        d[2]=Direction.SE;
        break;
      case SE:
        d[0]=Direction.NE;
        d[1]=Direction.SE;
        d[2]=Direction.SW;
        break;
      case SW:
        d[0]=Direction.SE;
        d[1]=Direction.SW;
        d[2]=Direction.NW;
        break;
      case NW:
        d[0]=Direction.SW;
        d[1]=Direction.NW;
        d[2]=Direction.NE;
        break;
    }
    return d;
}
