import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class sparkler extends PApplet {

ArrayList <Point> pts = new ArrayList<Point>();

public void setup()
{
  //size(800,600,P2D);
  
}

public void start()
{
  ellipseMode(CENTER);
  background(0xff1c1c1c);
}

public void drawOver()
{
  fill(0xff000000, 20);
  noStroke();
  rect(0,0,width,height);
}

public void draw()
{
  drawOver();
  for (Point p : pts)
  {
    p.draw(1);
  }
  for (int i = pts.size() - 1; i > -1; i--)
  {
    Point p = pts.get(i);
    if (p.pop) 
    {
      pts.remove(p);
      //if too small
      if (p.size <= 0.1f){noStroke();fill(p.col[0],p.col[1],p.col[2]);ellipse(p.pos.x, p.pos.y, 5, 5);continue;}
      int max = (int)random(0, 4); //0,1,2,3
      //if dead end
      if (max == 0){noStroke();fill(0xffdb8553);ellipse(p.pos.x, p.pos.y, p.size*2, p.size*2);continue;}
      ArrayList <Integer> indices = new ArrayList<Integer>();
      for (int x = 0; x < max; x++){indices.add(x);}
      Direction Dirs[] = getDirsFrom(p.going);
      for (int j = 0; j < max; j++)
      {
        int sel = (int)random(0,indices.size());
        Point t = new Point(p.pos, Dirs[sel], random(0.5f * p.speed, 1.1f * p.speed),
                                random(0.6f * p.size, 0.9f * p.size));
        t.col = p.col;
        pts.add(t);
      }
    }
  }
  //fill(#ffffff);
  //text("objs:" + pts.size(), mouseX+5, mouseY+5);
  boolean kp = mousePressed;
  if (pts.size() < 50 && (kp || (int)random(0,frameRate)==0))
  {
    Point t = new Point(kp?new PVector(mouseX, mouseY):
            new PVector((int)random(.4f*width,.6f*width),(int)random(.4f*height,.6f*height)),
                        getRandomDir(), 
                            random(3,10),
                                random(7,12));
    pts.add(t);
    noStroke();fill(0xff63075e);ellipse(t.pos.x, t.pos.y, t.size*3, t.size*3);
  } //else if (pts.size() ==0) { drawOver(); }
}
class Point
{
  Direction going;
  PVector pos;
  float speed;
  float size;
  boolean pop = false;
  int[] col = new int[3];
  public Point(PVector p, Direction d, float s, float z)
  {
    pos = p.copy();
    going = d;
    speed = s;
    size = z;
    col = genColor(100,255); //gen new color, replace if child
  }
  public void draw(float dt)
  {
    PVector old = pos.copy();
    switch (going)
    {
      case NE:
      pos.add(speed*dt, speed*dt);
        break;
      case SE:
      pos.add(speed*dt, -speed*dt);
        break;
      case SW:
      pos.add(-speed*dt, -speed*dt);
        break;
      case NW:
      pos.add(-speed*dt, speed*dt);
        break;
    }
    stroke(0xffffffff);
    strokeWeight(size);
    strokeCap(PROJECT);
    line(old.x, old.y, pos.x, pos.y);
    if ((int)random(0, sqrt(size*100)) == 0)
    {
      pop = true;
    }
  }
}

public int[] genColor(int min, int max)
{
  return new int[]{(int)random(min,max),(int)random(min,max),(int)random(min,max)};
}

enum Direction
{
  NE, SE, SW, NW
}

static final Direction[] ds = new Direction[]{Direction.NE, 
                                              Direction.SE, 
                                              Direction.SW, 
                                              Direction.NW};

public Direction getRandomDir()
{
  return ds[(int)random(0,4)];
}

public Direction[] getDirsFrom(Direction prev)
{
  Direction d[] = new Direction[3];
  switch (prev)
    {
      case NE: 
        d[0]=Direction.NW;
        d[1]=Direction.NE;
        d[2]=Direction.SE;
        break;
      case SE:
        d[0]=Direction.NE;
        d[1]=Direction.SE;
        d[2]=Direction.SW;
        break;
      case SW:
        d[0]=Direction.SE;
        d[1]=Direction.SW;
        d[2]=Direction.NW;
        break;
      case NW:
        d[0]=Direction.SW;
        d[1]=Direction.NW;
        d[2]=Direction.NE;
        break;
    }
    return d;
}
  public void settings() {  fullScreen(P2D); }
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "sparkler" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
